module CLK_DIV(
	iCLK,
	iRESET_N,
	iCLK_DIV_VALUE,
	oCLK
);


/*****************************************************************************
 *                           Parameter Declarations                          *
 *****************************************************************************/

parameter CND_WIDTH = 16;


/*****************************************************************************
 *                             Port Declarations                             *
 *****************************************************************************/

input 			iCLK;
input 			iRESET_N;
input	[CND_WIDTH-1:0]	iCLK_DIV_VALUE;
output 			oCLK;
reg 			oCLK;
reg		[CND_WIDTH-1:0]	CLK_DIV_VALUE;

/*****************************************************************************
 *                 Internal wires and registers Declarations                 *
 *****************************************************************************/

reg [CND_WIDTH-1:0] cnt;
reg clk_high;

/*****************************************************************************
 *                             Sequential logic                              *
 *****************************************************************************/

always@(posedge iCLK)
begin
	if (iRESET_N == 1'b0)
	begin
		cnt <= 0;
		CLK_DIV_VALUE <= (iCLK_DIV_VALUE == 0)?0:iCLK_DIV_VALUE - 1;
	end
	else
	begin
		cnt <= cnt + 1'b1;
		if (cnt == CLK_DIV_VALUE)
			cnt <= 0;
	end
end

always@(posedge iCLK)
begin
	if (iRESET_N == 1'b0)
	begin
		clk_high <= 1'b0;
		oCLK <= 0;
	end
	else if (cnt == CLK_DIV_VALUE)
	begin
		oCLK <= (clk_high)?1'b0:1'b1;
		clk_high <= clk_high?1'b0:1'b1;
	end
end


endmodule

